'use strict';

const utils = require( './utils.js' );

module.exports = utils.createCollectionMethodRule(
	[
		'on',
		'off',
		'bind',
		'unbind',
		'live',
		'die'

	],
	( node ) => {
		if ( node === true ) {
			return 'Prefer `$.on`/`$.off` or `EventTarget#addEventListener`/`removeEventListener`';
		} else {
			switch ( node.callee.property.name ) {
				case 'on':
				case 'bind':
				case 'live':
					return `Prefer \`EventTarget#addEventListener\` to $.${node.callee.property.name}'`;
				case 'off':
				case 'unbind':
				case 'die':
					return `Prefer \`EventTarget#removeEventListener\` to $.${node.callee.property.name}'`;
			}
		}
	},
	{
		fixable: 'code',
		fix: utils.eventShorthandFixer
	}
);
